/* 3d.h
 *
 * Functions used by graphical clients for parsing, moving, deleting, etc..
 * 3d objects. The caller need not know if these functions are being
 * used with s3dt or Inventor or any other graphical system.
 */
#if !defined(THREED_H)
#define THREED_H

#include "sim.h"
#include "client.h"

/* Function prototypes
 */
void setup_scenegraph_3d(void);
int supported_3d(void);
int parse_3d(int filed);
int parse_3ds(int filed);
void output_rgb_3d(plview *plv, FILE *fp);
void move_3d(char *name, double dx, double dy, double dz);
void del_3d(char *name);
void clear_3d(void);
void rotate_3d(char *name, double ang, double x, double y, double z);
void colour_3d(char *name, int r, int g, int b);
void shade_3d(char *name, int shd);
void need_redraw(void);
void shutdown_3d(void);
void boundingbox_3d(double *x1, double *y1, double *z1,
		    double *x2, double *y2, double *z2);
void visible_3d(char *name, int vis);

#endif /* !defined(THREED_H) */

