/* graphics.h
 *
 * Function prototypes called by the user interface to initialise and control
 * s3dt / Inventor in an X11 window.
 */
#if !defined(GRAPHICS_H)
#define GRAPHICS_H

#include "client.h"

/* X11 include files
 */
#undef NeedFunctionPrototypes
#define NeedFunctionPrototypes 1
#include <X11/Xlib.h>
#include <X11/X.h>

/* Function prototypes from s3dt.y / inventor.y
 */
void init_3d(char *display_name, Window par, int x, int y, int w, int h);
void new_3d_level(void);
int threed_fd(void);
int render_3d(plview *plv);
long best_colour(int red, int green, int blue);
void check_3d(void);
void resize_3d(int x, int y, int w, int h);
char *onscreen_3d(int x, int y);
void highlight_3d(char *name);
void unhighlight_3d(void);
int get_3d_click(char **n, int *b);

/* From 3dmap.c
 */
void init_map(Display *display, int w, int h);
Pixmap get_map_pixmap(void);
void create_base_map(Display *display);
void create_player_map(Display *display, plview *plv);

#endif /* !defined(GRAPHICS_H) */
