#include "jx.h"

void JXAddListText(Display *display,JXgadget *gadg,char *text)
{
JXtext *nw;
char buf[300],*t=buf;
int i,w;
Bool done=False;
double maxlns;

if (gadg->type != slist) {
	printf("JX : attempted to add text to a non-sliding list"
	 " gadget\n");
	return;
	}

if (gadg->jxgslist.wrap) {
	/* Possibly add several lines, after wrapping
	 */
	strcpy(buf,text);
	w=gadg->w-22;
	while(!done) {
		/* find max number of chars that fit into window */
		for(i=1;t[i] && XTextWidth(font_info,t,i)<w-4;i++);
		/* i=chars to add this line, t=start of this new line */
		if (!t[i])
			done=True;
		else
			i=i-1;
		nw=(JXtext *)malloc(sizeof(JXtext));
		nw->str=(char *)malloc(i+1);
		strncpy(nw->str,t,i);
		nw->str[i]='\0';
		nw->next=gadg->jxgslist.buf;
		gadg->jxgslist.buf=nw;
		gadg->jxgslist.lines++;
		t = &t[i];
		}
	}
else {
	/* Add only one un-wrapped line
	 */
	nw = calloc(1,sizeof(JXtext));
	nw->str = strcpy(malloc(strlen(text)+1),text);
	nw->width = XTextWidth(font_info,text,strlen(text));
	nw->mark  = 0;
	nw->next = gadg->jxgslist.buf;
	gadg->jxgslist.buf = nw;
	gadg->jxgslist.lines++;
	}

gadg->jxgslist.cline = -1;

/* Change the proportional slider at the side of the window */
maxlns = (gadg->h-6)/(font_info->ascent+font_info->descent);
JXSetOption(display,gadg->jxgslist.slg,PropFrac,
	    (double)maxlns/(double)gadg->jxgslist.lines,0);
}


void JXAddListTextSorted(Display *display, JXgadget *gadg, char *text)
{
JXtext **prv;
JXtext *ntxt;
int maxlns;

if (gadg->type != slist) {
	printf("JX : attempted to add text to a non-sliding list"
	 " gadget\n");
	return;
	}

/* Insert into linked list
 */
ntxt = calloc(1,sizeof(JXtext));
ntxt->str   = strcpy(malloc(strlen(text)+1),text);
ntxt->width = XTextWidth(font_info,text,strlen(text));
ntxt->mark  = 0;
for(prv=&gadg->jxgslist.buf; *prv && strcmp((*prv)->str,text) > 0;
    prv=&((*prv)->next))
	;
ntxt->next = *prv;
*prv = ntxt;

/* Update gadget
 */
gadg->jxgslist.lines++;
gadg->jxgslist.cline = -1;
maxlns = (gadg->h-6)/(font_info->ascent+font_info->descent);
JXSetOption(display,gadg->jxgslist.slg,PropFrac,
	    (double)maxlns/(double)gadg->jxgslist.lines,0);
}

