#include "jx.h"

/* Add an item to an already existing menu gadget.
 *
 * display		- X server connection
 * gadg			- the menu gadget
 * text			- the line of text to add
 */
void JXAddMenuItem(Display *display,JXgadget *gadg,char *text)
{
JXtext *nw, **last;
int i,w;

if (gadg->type != menu && gadg->type != combo) {
	printf("JX : attempted to add entries to something that isn't"
	 " a menu or combo\n");
	return;
	}

/* find the pointer to the null end-of-list pointer */
if (gadg->type == menu)
	for(last = &(gadg->jxgmenu.buf); *last; last = &((*last)->next))
		;
else
	for(last = &(gadg->jxgcombo.buf); *last; last = &((*last)->next))
		;

/* create the new menu item, and add it to the list */
nw = (JXtext *)malloc(sizeof(struct JXtext));
nw->next = NULL;
nw->width = XTextWidth(font_info,text,strlen(text));
nw->mark  = 0;
nw->str = (char *)malloc(strlen(text)+1);
strcpy(nw->str,text);
*last = nw;

if (gadg->type == menu)
	gadg->jxgmenu.lines++;
else
	gadg->jxgcombo.lines++;
}

