#include "jx.h"

Bool exposepred(Display *display, XEvent *event, char *arg)
{
if (event->type == Expose || event->type == MapNotify)
        return(True);
else
        return(False);
}

/* JXCreateGadget - creates a new gadget, and draws it
 *
 * win          - parent window of gadget
 * x            - x position
 * y            - y position
 * width        - width of gadget
 * height       - height of gadget
 * type         - gadget type (boolean, toggle, etc...)
 * str          - label or initial string of gadget
 * display      - connection to the server
 * col1         - the highlight colour of the gadget
 * col2         - the body colour of the gadget
 * col3         - the background colour of the gadget
 */
JXgadget *JXCreateGadget(Window win, int x, int y, int width, int
height, JXgtype type, char *str, Display *display, long col1, long col2,
 long col3)
{
JXgadget *gadg;
XEvent event;
XSetWindowAttributes winattr;

gadg = (JXgadget *)malloc(sizeof(JXgadget));
gadg->next=glist;
glist=gadg;
gadg->window=XCreateSimpleWindow(display,win,x,y,width-1,height-1,0,
 0,col3);
/*
winattr.do_not_propagate_mask=-1;
XChangeWindowAttributes(display,gadg->window,CWDontPropagate,&winattr);
*/
gadg->parent=win;
gadg->x=x;
gadg->y=y;
gadg->w=width-1;
gadg->h=height-1;
gadg->topcolour=col1;
gadg->botcolour=col2;
gadg->backcolour=col3;
gadg->type=type;
gadg->number=gadget_count++;
gadg->owner=NULL;
gadg->label=(char *)malloc(80);
if (type==boolean) {
        XSelectInput(display,gadg->window,ExposureMask |
         ButtonReleaseMask | LeaveWindowMask | ButtonPressMask);
        strcpy(gadg->label,str);
        gadg->jxgboolean.state=0;
        }
else if (type==toggle) {
        XSelectInput(display,gadg->window, ButtonPressMask |
         ExposureMask);
        strcpy(gadg->label,str);
        gadg->jxgtoggle.state=0;
        }
else if (type==string) {
        XSelectInput(display,gadg->window,ExposureMask |
         KeyPressMask);
        strcpy(gadg->label,str);
        gadg->jxgstring.len=strlen(str);
	gadg->jxgstring.maxlen=80;
        }
else if (type==slider) {
	XSelectInput(display,gadg->window,ButtonPressMask |
	 Button1MotionMask | ExposureMask | ButtonReleaseMask);
	gadg->jxgslider.pos=0;
	gadg->jxgslider.npos=0.0;
	if (height > width) {
		gadg->jxgslider.horiz=False;
		gadg->jxgslider.slsize=width-5;
		}
		
	else {
		gadg->jxgslider.horiz=True;
		gadg->jxgslider.slsize=height-5;
		}
	}
else if (type==slist) {
	JXgadget *scrl;

	/* map itself */
	XSelectInput(display,gadg->window,ExposureMask);
	XMapWindow(display,gadg->window);
        XFlush(display);
        XIfEvent(display,&event,exposepred,"");
	
	/* create slider child */
	gadg->jxgslist.buf   = NULL;
	gadg->jxgslist.lines = 0;
	gadg->jxgslist.cline = -1;		/* -1 to force re-draw */
	scrl=JXCreateGadget(gadg->window,gadg->w-16,0,17,gadg->h+1,
	 slider,"",display,col1,col2,col3);
	JXMoveSlider(display,scrl,1);
	gadg->jxgslist.slg=scrl;
	scrl->owner=gadg;
	}
/* note - gadgets with children have to map themselves BEFORE creating
 * their descendants, to avoid a deadlock.
 */
if (type != slist) {
	XMapWindow(display,gadg->window);
	XFlush(display);
	XIfEvent(display,&event,exposepred,"");
	}
JXRedrawGadget(display,gadg);
return(gadg);
}

