#include "jx.h"
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>

void JXFileList(Display *display, JXgadget *gadg, char *path)
{
FILE *fp;
char com[200];
struct stat finfo;
DIR *dlist;
struct dirent *dent;

/* Is this a valid operation for this gadget? 
 */
if (gadg->type != file) {
	printf("JX : Attempted to update file list on a non-file gadget\n");
	return;
	}

/* Clear out old file list */
JXDeleteText(gadg->jxgfile.ls->jxgslist.buf);
gadg->jxgfile.ls->jxgslist.buf = NULL;
gadg->jxgfile.ls->jxgslist.lines = 0;
gadg->jxgfile.ls->jxgslist.cline = 0;
JXSetOption(display,gadg->jxgfile.ls->jxgslist.slg,PropFrac,1.0,0);

/* Is the given path a readable, existing directory? */
if (!JXIsDirectory(path)) {
	JXAddListText(display,gadg->jxgfile.ls,"Not a directory");
	JXRedrawGadget(display,gadg);
	return;
	}

/* Get a file list, using dir calls.
 */
dlist = opendir(FilepathStringFromFile(gadg));
if (dlist == NULL) {
	/* Can't access this! */
	JXAddListText(display,FilelistFromFile(gadg),"Cannot open this file");
	JXRedrawGadget(display,gadg);
	return;
	}
while((dent = readdir(dlist)) != NULL) {
	char fname[100];

	if (dent->d_ino && dent->d_name[0] != '.') {
		/* If this directory entry has something in it, and it
		 * does not start with ".", then add it to the list.
		 */
		/* strncpy(fname,dent->d_name,dent->d_namlen); */
		/* fname[dent->d_namlen] = '\0'; */
		strcpy(fname,dent->d_name);
		JXAddListTextSorted(display,FilelistFromFile(gadg),fname);
		}
	}
closedir(dlist);

/* Force a re-draw of the file list gadget.
 */
FilelistFromFile(gadg)->jxgslist.cline = -1;
JXRedrawGadget(display,FilelistFromFile(gadg));
}



