#include "jx.h"

/* Sends a message from a gadget to it's parent, using a ClientMessage.
 * Usually used to notify a program (or higher-level gadget) that
 * one of it's child gadgets has been pressed.
 * Data is stored in the data.l array of the message, with the
 * first long storing the gadget the message is from, and the second
 * the message code.
 *
 * display		- connection to the server
 * to			- window message is to
 * number		- id of gadget message is from
 * mesg			- message code
 */
void JXNotify(Display *display, Window to, int number, long mesg)
{
XClientMessageEvent m;

/* set up message */
m.type = ClientMessage;
m.send_event = True;
m.display = display;
m.window = to;
m.message_type = 0;
m.format = 32;
m.data.l[0] = number;
m.data.l[1] = mesg;

/* XPutBackEvent(display,(XEvent *)&m); */
XSendEvent(display,to,True,0,(XEvent *)&m);
}

