#include "jx.h"
#include "jx_left.h"
#include "jx_right.h"
#include "jx_up.h"
#include "jx_down.h"

GC gc=0;
XFontStruct *font_info;
JXgadget *glist;
int gadget_count;
Pixmap jx_left,jx_right,jx_up,jx_down;
Window root;
int def_depth;

void JXStartup(Display *display, int screen_num)
{
XGCValues gcvals;
char stipple_bits[2];		/* for inactive gadgets */

stipple_bits[0] = 0x01;
stipple_bits[1] = 0x02;
root      = RootWindow(display,screen_num);
def_depth = DefaultDepth(display,screen_num);
gc        = XCreateGC(display,root,0,NULL);
font_info = XLoadQueryFont(display,"-adobe-courier-medium-r-*--12-*-*"
 "-*-*-*-*-*");

if (!font_info) {
	font_info = XLoadQueryFont(display,"fixed");
	if (!font_info) {
		printf("JX : couldn't open 'fixed' font!\n");
		exit(1);
		}
	}
XSetFont(display,gc,font_info->fid);
glist=NULL;
gadget_count=0;

/* Stop NoExpose events from occuring when JX is using the GC.
 * Set the stipple pattern for inactive gadgets
 */
gcvals.graphics_exposures = False;
gcvals.stipple = XCreateBitmapFromData(display,root,stipple_bits,2,2);
XChangeGC(display,gc,GCGraphicsExposures | GCStipple,&gcvals);

/* create arrow pixmaps */
jx_left=XCreateBitmapFromData(display,RootWindow(display,screen_num),
 jx_left_bits,arrow_w,arrow_h);
jx_right=XCreateBitmapFromData(display,RootWindow(display,screen_num),
 jx_right_bits,arrow_w,arrow_h);
jx_up=XCreateBitmapFromData(display,RootWindow(display,screen_num),
 jx_up_bits,arrow_w,arrow_h);
jx_down=XCreateBitmapFromData(display,RootWindow(display,screen_num),
 jx_down_bits,arrow_w,arrow_h);
}

