#include "jx.h"
#include <sys/types.h>
#include <sys/stat.h>

/* Determines if a given pathname is a directory or not.
 */
int JXIsDirectory(char *path)
{
struct stat stbuf;

if (stat(path,&stbuf) == -1)
	return -1;
else if ((stbuf.st_mode & S_IFMT) == S_IFDIR)
	return 1;
else
	return 0;
}

/* Deletes a linked list of JXtext structures.
 */
void JXDeleteText(JXtext *tx)
{
if (tx) {
        JXDeleteText(tx->next);
        free(tx);
        }
}


/* JXGetWindowPos
 * Find the REAL position of a window
 */
void JXGetWindowPos(Display *display, Window w, int *x, int *y)
{
if (w == root)
	*x = *y = 0;
else {
	XWindowAttributes xwa;			/* for getting pos */
	Window wroot,wparent,*wchildren;	/* for getting parent */
	unsigned int wchildc;
	int px,py;

	XGetWindowAttributes(display,w,&xwa);
	XQueryTree(display,w,&wroot,&wparent,&wchildren,&wchildc);
	XFree(wchildren);
	JXGetWindowPos(display,wparent,&px,&py);
	*x = px+xwa.x;
	*y = py+xwa.y;
	}
}


/* JXExpandTabs
 * Expand the tabs in a string to 8 spaces
 */
char *JXExpandTabs(char *s)
{
static char e[1024];
char *ep = e;

for(; *s; s++) {
	if (*s == '\t') {
		int j;
		for(j=0; j<8; j++)
			*(ep++) = ' ';
		}
	else
		*(ep++) = *s;
	}
*ep = 0;
return e;
}

