#include "jx.h"

/* Adds a new gadget to the list of those owned by a particular window
 * gadget.
 */
JXgadget *JXWindowAdd(Display *display, JXgadget *wn, long col1,long col2,
		 long col3,JXgtype type,...)
{
JXgadget *ng;

va_list ap;

va_start(ap,type);
ng = JXRealNewGadget(display,wn->window,col1,col2,col3,type,ap);
wn->jxgwindow.gl[wn->jxgwindow.gcount++] = ng;
va_end(ap);
return ng;
}


/* JXWindowDelete
 * Remove and free one gadget from a window gadget
 */
void JXWindowDelete(Display *display, JXgadget *wn, JXgadget *v)
{
int i;

for(i=0; i<wn->jxgwindow.gcount; i++)
	if (wn->jxgwindow.gl[i] == v) {
		int j;

		JXFreeGadget(display,v);
		for(j=i+1; j<wn->jxgwindow.gcount; j++)
			wn->jxgwindow.gl[j-1] = wn->jxgwindow.gl[j];
		wn->jxgwindow.gcount--;
		return;
		}
printf("JX : attempted to remove a gadget from a window that is not in that "
	"window.\n");
}


/* JXWindowClear
 * Remove all gadgets from a window gadget
 */
void JXWindowClear(Display *display, JXgadget *wn)
{
int i;

for(i=0; i<wn->jxgwindow.gcount; i++)
	JXFreeGadget(display,wn->jxgwindow.gl[i]);
wn->jxgwindow.gcount = 0;
}


