/* object.c
 *
 * Functions for manipulating objects
 */
#include "sim.h"

static hashtable ot = {0};

/* create_object
 * Allocate and init a new object
 */
object *create_object(void)
{
object *no = scalloc(1,sizeof(object));

no->gettable = 1;
no->weight   = 0.0;
no->inv      = NULL;
return no;
}

/* Hash table functions
 */
void add_object(object *o)
{ add_entry(&ot,o); }

object *lookup_object(char *name)
{ return lookup_entry(&ot,name); }

void reset_object(void)
{ reset_position(&ot); }

object *next_object(void)
{ return next_position(&ot); }

void remove_object(object *o)
{ remove_entry(&ot,o); }

void clear_objects(void)
{ clear_entries(&ot,(freefunc)free_object); }

/* free_object
 * Deep-free an object
 */
void free_object(object *o)
{
if (o->desc)
	free(o->desc);
free(o);
}

