#include "sim.h"

int fd_debug = 0;		/* needed in fdio.c */

int main(int argc, char **argv)
{
int fd;				/* fd to read from */
unsigned char *data;		/* texture data */
int w,h;			/* size of texture */
int i,tc;

/* parse command line args and read texture
 */
if (argc == 1)
	fd = dup(0);
else if ((fd = open(argv[1],O_RDONLY)) == -1) {
	logerror("Couldn't open file %s",argv[1]);
	exit(1);
	}
else {
	logerror("usage : %s [filename]",argv[0]);
	exit(0);
	}
if ((data = read_ppm_texture(fd,&w,&h)) == NULL) {
	logerror("Error reading texture from %s",argc==1 ? "stdin" : argv[1]);
	exit(1);
	}

/* Output texture
 */
fdprintf(1,"texture %d %d {\n",w,h);
write_encoded_texture(1,data,w,h);
fdprintf(1,"\t}\n");

free(data);
}

