#include "s3dt.h"
#include "s3dtint.h"
#include "s3view.h"

/* S3CallObjectFuncs
 * Call all functions registered for doing stuff after each object
 * has been drawn.
 */
void S3CallObjectFuncs(Display *display, S3view *vw, S3object *ob, S3objtab *oh)
{
}


/* S3CallBeforeFuncs
 * Call all functions registered for doing stuff before the 3d graphics
 * are drawn.
 */
void S3CallBeforeFuncs(Display *display, S3view *vw, S3objtab *oh)
{
}


/* S3CallAfterFuncs
 * Call all functions registered for doing stuff after the 3d graphics
 * have been drawn
 */
void S3CallAfterFuncs(Display *display, S3view *vw, S3objtab *oh)
{
}


static S3efree efreefunc=NULL;	/* function to free extra data */

/* S3SetEFreeFunc
 * Set the callback function for freeing the extra_data part of an object
 */
void S3SetEFreeFunc(S3efree eff)
{
efreefunc = eff;
}

/* S3GetEFreeFunc
 * Return the callback function for freeing the extra_data part of an
 * object
 */
S3efree S3GetEFreeFunc(void)
{
return efreefunc;
}


static S3ecreate ecreatefunc=NULL;	/* function to allocate extra data */

/* S3SetECreateFunc
 * Set the callback for allocating a new extra data part of an object
 */
void S3SetECreateFunc(S3ecreate ecf)
{
ecreatefunc = ecf;
}

/* S3GetECreateFunc
 * Returns the callback function for allocating a new extra data part
 * of an object.
 */
S3ecreate S3GetECreateFunc(void)
{
return ecreatefunc;
}


static S3eadd eaddfunc;

/* S3SetEAddFunc
 * Set the function called when an extra_data item is encountered when
 * parsing an object file
 */
void S3SetEAddFunc(S3eadd eaf)
{
eaddfunc = eaf;
}

/* S3GetEAddFunc
 * Returns the function for adding extra_data items
 */
S3eadd S3GetEAddFunc(void)
{
return eaddfunc;
}


static S3ewrite ewritefunc;

/* S3SetEWriteFunc
 * Sets the function called to write an extra_data block
 */
void S3SetEWriteFunc(S3ewrite ewf)
{
ewritefunc = ewf;
}

/* S3GetEWriteFunc
 * Returns the function to write and extra_data block
 */
S3ewrite S3GetEWriteFunc(void)
{
return ewritefunc;
}

