#include "s3dt.h"
#include "s3dtint.h"
#include <time.h>

#define FPS_FRAMES 100

/* S3CountFps
 * Display the frames / second count every FPS_FRAMES frames.
 * This should be called after each call to S3RenderView()
 */
void S3CountFps(void)
{
static int frame = 0;
static double lasttime = -1;

if (lasttime < 0)
	lasttime = S3GetTime();		/* only way to init statics */

if (++frame == FPS_FRAMES) {
	double nowtime = S3GetTime();

	printf("%f fps\n",frame / (nowtime - lasttime));
	lasttime = nowtime;
	frame = 0;
	}
}

