#include "s3dt.h"
#include "s3dtint.h"
#include "s3view.h"

/* S3CreateWindow
 * Create a top level X window, and a s3 view to associate with it
 */
S3view *S3CreateSimpleWindow(Display *display, int w, int h)
{
int screen_num     = DefaultScreen(display);
Screen *screen_ptr = DefaultScreenOfDisplay(display);
Window root        = RootWindow(display,screen_num);

return S3CreateWindow(display,root,100,100,w,h,rm_zbufshm);
}


/* S3CreateWindow
 * Create an X11 window, and a view the makes use of it.
 */
S3view *S3CreateWindow(Display *display, Window par, int x, int y, int w,
		       int h, S3rmodetype rmode)
{
Colormap cmap;
Window win;
S3view *vw;

cmap = S3CreateDefaultColourmap(display);
win = XCreateSimpleWindow(display,par,100,100,w,h,1,0,0);
XSetWindowColormap(display,win,cmap);
XMapWindow(display,win);
XFlush(display);

vw = S3CreateView(display,win,rmode);
return vw;
}

