#include "s3dt.h"
#include "s3dtint.h"

/* S3GetObjectId
 * Extracts an id from an object
 */
void S3GetObjectId(S3object *ob, int *id)
{
*id = ob->id;
}


/* S3GetObjectPos
 * Extracts the position from an object
 */
void S3GetObjectPos(S3object *ob, double *x, double *y, double *z)
{
*x = RealToDbl(ob->pos.x);
*y = RealToDbl(ob->pos.y);
*z = RealToDbl(ob->pos.z);
}


/* S3GetObjectParent
 * Extracts the parent object pointer from an object
 */
void S3GetObjectParent(S3object *ob, S3object **par)
{
*par = ob->par;
}


/* S3GetObjectChildren
 * Extracts the child objects array and number of child objects from an object
 */
void S3GetObjectChildren(S3object *ob, S3object ***children, int *cc)
{
*children = ob->so;
*cc       = ob->soc;
}


/* S3GetObjectName
 * Extracts the name string from an object
 */
void S3GetObjectName(S3object *ob, char **name)
{
*name = ob->name;
}


/* S3GetObjectPointC
 * Extract the number of points in an object
 */
void S3GetObjectPointC(S3object *ob, int *ptc)
{
*ptc = ob->ptc;
}


/* S3GetObjectFaceC
 * Extract the face count from an object
 */
void S3GetObjectFaceC(S3object *ob, int *facec)
{
*facec = ob->facec;
}

