#include "s3dt.h"
#include "s3dtint.h"

/* S3HighLightObject
 * Set highlighting on an object
 */
void S3HighLightObject(S3object *obj, int col)
{
int i;

obj->highlight = col;
for(i=0; i<obj->soc; i++)
	S3HighLightObject(obj->so[i],col);
}


/* S3UnHighLightObject
 * Cancel highlighting on an object
 */
void S3UnHighLightObject(S3object *obj)
{
int i;

obj->highlight = -1;
for(i=0; i<obj->soc; i++)
	S3UnHighLightObject(obj->so[i]);
}


/* S3UnHighLightAll
 * Cancel highlighting on all objects in a table
 */
void S3UnHighLightAll(S3objtab *ot)
{
S3object *ob;

for(ob=ot->head; ob; ob=ob->next)
	ob->highlight = -1;
}

