#include "s3dtint.h"

/* S3Malloc
 * Allocate memory or die trying
 */
void *S3Malloc(int size)
{
void *mem = malloc(size);

if (!mem) {
	fprintf(stderr,"S3Malloc : failed to malloc %d bytes\n",size);
	exit(10);
	}
return mem;
}


/* S3Calloc
 * Allocate and zero memory, or die trying
 */
void *S3Calloc(int num, int size)
{
void *mem = calloc(num,size);

if (!mem) {
	fprintf(stderr,"S3Calloc : failed to calloc %d bytes\n",num*size);
	exit(10);
	}
return mem;
}


/* S3Free
 * Call free on a pointer if it isn't null
 */
void S3Free(void *ptr)
{
if (ptr)
	free(ptr);
}

