#include "s3dt.h"
#include "s3dtint.h"

/* S3ObjectCentroid
 * Find the average x,y and z values of the points of this object.
 */
void S3ObjectCentroid(S3object *obj, double *cx, double *cy, double *cz)
{
real xs = Real0, ys = Real0, zs = Real0;
int i;

if (obj->ptc == 0) {
	*cx = *cy = *cz = 0.0;
	return;
	}
for(i=0; i<obj->ptc; i++) {
	xs = AddReal(xs,obj->pt[i]->x);
	ys = AddReal(ys,obj->pt[i]->y);
	zs = AddReal(zs,obj->pt[i]->z);
	}
*cx = RealToDbl(xs) / obj->ptc;
*cy = RealToDbl(ys) / obj->ptc;
*cz = RealToDbl(zs) / obj->ptc;
}

