#include "s3dt.h"
#include "s3dtint.h"

/* S3WriteShowPoly
 * Output a s3dt object table in showpoly format
 */
void S3WriteShowPoly(S3objtab *ot, FILE *fp)
{
S3object *o;

fprintf(fp,"Frame\n");
for(o=ot->head; o; o=o->next) {
	int i;

	for(i=0; i<o->facec; i++) {
		S3polygon *p = o->face[i];
		int j;
		double r = ((p->colour&0xff0000)>>16) / 255.0;
		double g = ((p->colour&0x00ff00)>>8) / 255.0;
		double b =  (p->colour&0x0000ff) / 255.0;

		fprintf(fp,"Colour [%f %f %f]\n",r,g,b);
		fprintf(fp,"Poly");
		for(j=0; j<p->vertc; j++) {
			S3point *pt = o->pt[p->vert[j]];
			double x = RealToDbl(AddReal(pt->x,o->pos.x));
			double y = RealToDbl(AddReal(pt->y,o->pos.y));
			double z = RealToDbl(AddReal(pt->z,o->pos.z));

			fprintf(fp," <%f %f %f>",x,y,z);
			}
		fprintf(fp,"\n");
		}
	}
}

