#include "s3dt.h"
#include "s3dtint.h"
#include "s3view.h"

static int ern;
static int S3ErrorHandler(Display *display, XErrorEvent *xeev);

/* S3TrapOn
 * Turn on X error trapping
 */
void S3TrapOn(void)
{
XSetErrorHandler(S3ErrorHandler);
ern = 1;
}


/* S3TrapOff
 * Turn off X error trapping, and return zero if some error occurred while
 * trapping was on.
 */
int S3TrapOff(void)
{
XSetErrorHandler(NULL);
return ern;
}


/* S3ErrorHandler
 * Function called on error
 */
static int S3ErrorHandler(Display *display, XErrorEvent *xeev)
{
ern = 0;
}

