#include "s3dt.h"
#include "s3view.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

main()
{
Display *display;		/* connection to X server */
S3view *vw;			/* viewpoint and window info */
S3objtab *oh;			/* scene to draw in window */
S3object *cube;			/* my cube */
S3object *cone[8];		/* my cones */
int i;

if ((display = XOpenDisplay(NULL)) == NULL) {
	printf("couldn't open display \"%s\"\n",XDisplayName(NULL));
	exit(2);
	}

/* Create a window to do our viewing in
 */
vw = S3CreateWindow(display,DefaultRootWindow(display),300,300,300,300,
		    rm_plane);

/* Create an object table, and add 8 cones and a cube to it
 */
oh = S3CreateObjectTable(tt_id);
cube = S3CreateCube(20,pt_plane | pt_lighted);
S3AddObject(oh,cube);
for(i=0; i<8; i++) {
	double rad = (i*45)/180.0*3.1415927;

	cone[i] = S3CreateCone((i+1)*32-1,pt_plane | pt_lighted);
	S3AddObject(oh,cone[i]);
	S3SetObjectPos(cone[i],cos(rad)*3,sin(rad)*3,0.0);
	}
/* S3HighLightObject(cone[0],127); */

/* Set the view to be circling around the cube
 */
S3SetViewType(vw,vt_circling);
S3SetViewTarget(vw,cube); 

#if 0
/* Set view to be looking at cube
 */
S3SetViewVrp(vw,2,2,2);
S3SetViewN(vw,-1,-1,-1);
#endif

/* Add a light source to the view
 */
S3AddViewLight(vw,10,10,1,1.0);
S3AddViewLight(vw,-10,5,-3,1.0);

/* Render the scene over and over again
 */
while(1) {
	S3RenderView(display,vw,oh);
	S3CountFps();
	}
}

